accounts/urls.py
from django.contrib.auth import views as auth_views
from django.urls import path


from accounts.views import (
    signup_view,
)

urlpatterns = [
    path("login/", auth_views.LoginView.as_view(), name="login"),
    path("logout/", auth_views.LogoutView.as_view(), name="logout"),
    path("signup/", signup_view, name="home"),
]

projects/urls.py
from django.urls import path

from projects.views import (
    ProjectListView,
    ProjectCreateView,
    ProjectDetailView,
)


urlpatterns = [
    path("", ProjectListView.as_view(), name="list_projects"),
    path("create/", ProjectCreateView.as_view(), name="create_project"),
    path("<int:pk>/", ProjectDetailView.as_view(), name="show_project"),
]

tasks/urls.py
from django.urls import path

from tasks.views import (
    TaskCreateView,
    TaskListView,
    TaskUpdateView,
)


urlpatterns = [
    path("create/", TaskCreateView.as_view(), name="create_task"),
    path("mine/", TaskListView.as_view(), name="show_my_tasks"),
    path("<int:pk>/complete/", TaskUpdateView.as_view(), name="complete_task"),
]

tracker/urls.py
from django.contrib import admin
from django.urls import path, include
from django.views.generic import RedirectView
from django.urls import reverse_lazy

urlpatterns = [
    path("admin/", admin.site.urls),
    path("projects/", include("projects.urls")),
    path("accounts/", include("accounts.urls")),
    path("tasks/", include("tasks.urls")),
    path(
        "",
        RedirectView.as_view(url=reverse_lazy("list_projects")),
        name="home",
    ),
]

accounts/models.py
# Create your models here.

projects/models.py
from django.db import models
from django.conf import settings


USER_MODEL = settings.AUTH_USER_MODEL


# Create your models here.
class Project(models.Model):
    name = models.CharField(max_length=200)
    description = models.TextField()
    members = models.ManyToManyField(USER_MODEL, related_name="projects")

    def __str__(self):
        return self.name

tasks/models.py
from django.db import models


# Create your models here.
class Task(models.Model):
    name = models.CharField(max_length=200)
    start_date = models.DateTimeField()
    due_date = models.DateTimeField()
    is_completed = models.BooleanField(default=False)
    project = models.ForeignKey(
        "projects.Project", related_name="tasks", on_delete=models.CASCADE
    )
    assignee = models.ForeignKey(
        "auth.User", null=True, related_name="tasks", on_delete=models.SET_NULL
    )

    def __str__(self):
        return self.name

accounts/forms.py
from django import forms
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User


class NewUserForm(UserCreationForm):
    email = forms.EmailField(required=True)

    class Meta:
        model = User
        fields = ["username", "email", "password1", "password2"]

    def save(self, commit=True):
        user = super(NewUserForm, self).save(commit=False)
        user.username = self.cleaned_data["username"]
        user.email = self.cleaned_data["email"]
        user.password1 = self.cleaned_data["password1"]
        user.password2 = self.cleaned_data["password2"]
        if commit:
            user.save()
        return user

accounts/views.py
from django.shortcuts import render
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth import login, authenticate
from django.shortcuts import redirect


# Create your views here.
def signup_view(request):
    form = UserCreationForm()
    if request.method == "POST":
        form = UserCreationForm(request.POST)
        if form.is_valid():
            form.save()
            username = form.cleaned_data.get("username")
            password = form.cleaned_data.get("password1")
            user = authenticate(username=username, password=password)
            user.create_user(username=username, password=password)
            login(request, user)
            return redirect("home")
    else:
        form = UserCreationForm()

    context = {"form": form}
    return render(request, "registration/signup.html", context)

projects/views.py
from django.urls import reverse_lazy
from django.views.generic.list import ListView
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView
from django.contrib.auth.mixins import LoginRequiredMixin

from projects.models import Project


# Create your views here.
class ProjectListView(LoginRequiredMixin, ListView):
    model = Project
    template_name = "project_temp/list.html"

    def get_queryset(self):
        return Project.objects.filter(members=self.request.user)


class ProjectCreateView(LoginRequiredMixin, CreateView):
    model = Project
    template_name = "project_temp/create.html"
    fields = ["name", "description", "members"]
    # success_url = reverse_lazy("show_project")

    def get_success_url(self):
        return reverse_lazy("show_project", args=[self.object.id])


class ProjectDetailView(LoginRequiredMixin, DetailView):
    model = Project
    template_name = "project_temp/detail.html"

    # def get_queryset(self):
    #     return Project.objects.filter(name=self.request.user)

tasks/views.py
from django.urls import reverse_lazy
from django.views.generic.edit import CreateView, UpdateView
from django.views.generic.list import ListView
from django.contrib.auth.mixins import LoginRequiredMixin

from tasks.models import Task


# Create your views here.
class TaskCreateView(LoginRequiredMixin, CreateView):
    model = Task
    template_name = "tasks_temp/create.html"
    fields = ["name", "start_date", "due_date", "project", "assignee"]

    def get_success_url(self):
        return reverse_lazy("show_project", args=[self.object.id])


class TaskListView(LoginRequiredMixin, ListView):
    model = Task
    template_name = "tasks_temp/list.html"

    def get_queryset(self):
        return Task.objects.filter(assignee=self.request.user)


class TaskUpdateView(LoginRequiredMixin, UpdateView):
    model = Task
    fields = ["is_completed"]
    success_url = reverse_lazy("show_my_tasks")

projects/templates/project_temp/create.html
<!DOCTYPE html>
<html>
    <head>
        <title></title>
    </head>
    <body>
        <main>
            <div>
                <h1>Create a new project</h1>
                <form method="post">
                    {% csrf_token %} {{ form.as_p }}
                    <button>Create</button>
                </form>
            </div>
        </main>
    </body>
</html>

projects/templates/project_temp/detail.html
<!DOCTYPE html>
<html>
    <head>
        <title></title>
    </head>
    <body>
        <main>
            <div>
                <h1>{{ project.name }}</h1>
                <p>{{ project.description }}</p>
                <h2>Tasks</h2>
                <p>
                    <a href="{% url 'create_task' %}">Create a new task</a>
                </p>
                {% if not project_list %}
                    <table>
                        <thead>
                            <tr>
                                <th>Name</th>
                                <th>Assignee</th>
                                <th>Start date</th>
                                <th>Due date</th>
                                <th>Is completed</th>
                            </tr>
                        </thead>
                        <tbody>
                            {% for task in project.tasks.all %}
                                <tr>
                                    <td>{{ task.name }}</td>
                                    <td>{{ task.assignee }}</td>
                                    <td>{{ task.start_date }}</td>
                                    <td>{{ task.due_date }}</td>
                                    <td>{{ task.is_completed }}</td>
                                </tr>
                            {% endfor %}
                        </tbody>
                    </table>
                {% else %}
                    <p>This project has no tasks</p>
                {% endif %}
            </div>
        </main>
    </body>
</html>

projects/templates/project_temp/list.html
<!DOCTYPE html>
<html>
    <head>
        <title></title>
    </head>
    <body>
        <main>
            <div>
                <h1>My Projects</h1>
                <p>
                    <a href="{% url 'create_project' %}">Create a project</a>
                </p>
                {% if not project_list %}
                    <p>You are not assigned to any projects</p>
                {% else %}
                    <table>
                        <thead>
                            <tr>
                                <th>Name</th>
                                <th>Number of tasks</th>
                            </tr>
                        </thead>
                        <tbody>
                            {% for task in project_list %}
                                <tr>
                                    <td>
                                        <a href="{% url 'show_project' task.pk %}">{{ task.name }}</a>
                                    </td>
                                    <td>{{ project_list|length }}</td>
                                </tr>
                            {% endfor %}
                        </tbody>
                    </table>
                {% endif %}
            </div>
        </main>
    </body>
</html>

projects/templates/tasks_temp/create.html
<!DOCTYPE html>
<html>
    <head>
        <title></title>
    </head>
    <body>
        <main>
            <div>
                <h1>Create a new task</h1>
                <form method="post">
                    {% csrf_token %} {{ form.as_p }}
                    <button type="submit">Create</button>
                </form>
            </div>
        </main>
    </body>
</html>

projects/templates/tasks_temp/list.html
<!DOCTYPE html>
<html>
    <head>
        <title></title>
    </head>
    <body>
        <main>
            <div>
                <h1>My Tasks</h1>
                {% if task_list %}
                    <table>
                        <thead>
                            <tr>
                                <td>Name</td>
                                <td>Start date</td>
                                <td>End date</td>
                                <td>
                                    {% if task.is_completed == True %}
                                        <p>Done</p>
                                    {% else %}
                                        <form method="post" action="{% url 'complete_task' task.id %}">
                                            {% csrf_token %}
                                            <input type="hidden" name="is_completed" value="True" />
                                            <button>Complete</button>
                                        </form>
                                    {% endif %}
                                </td>
                            </tr>
                        </thead>
                    </table>
                {% else %}
                    <p>You have no tasks</p>
                {% endif %}
            </div>
        </main>
    </body>
</html>